﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Sample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        #region Constructor
        /// <summary>
        /// Initializes a new instance of the <see cref="T:Sample.MainPage">MainPage</see> class. 
        /// </summary>
        /// <remarks></remarks>
        public MainPage()
        {
            this.InitializeComponent();
        }
        #endregion

        #region Click Events
        /// <summary>
        /// Called on Load Button clicked.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">An <see cref="T:Windows.UI.Xaml.RoutedEventArgs">RoutedEventArgs</see> that contains the event data.</param>
        /// <remarks></remarks>
        private async void LoadButton_Click(object sender, RoutedEventArgs e)
        {
            FileOpenPicker fileOpenPicker = new FileOpenPicker();
            fileOpenPicker.FileTypeFilter.Add(".doc");
            fileOpenPicker.FileTypeFilter.Add(".docx");
            fileOpenPicker.FileTypeFilter.Add(".rtf");
            StorageFile stgFile = await fileOpenPicker.PickSingleFileAsync();
            if (stgFile != null)
                await richTextBoxAdv.LoadAsync(stgFile);
        }
        /// <summary>
        /// Called on save as image button clicked.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">An <see cref="T:Windows.UI.Xaml.RoutedEventArgs">RoutedEventArgs</see> that contains the event data.</param>
        /// <remarks></remarks>
        private async void SaveAsImageButton_Click(object sender, RoutedEventArgs e)
        {
            if (richTextBoxAdv.PageCount <= 0)
                return;
            Canvas canvas = new Canvas();
            root.Children.Add(canvas);
            //Gets the bitmap image for first page of the document.
            BitmapImage bitmap = await richTextBoxAdv.GetPageAsImageAsync(0);
            Windows.UI.Xaml.Controls.Image tempimage = new Windows.UI.Xaml.Controls.Image();
            image.Source = bitmap;
            image.Height = 100;
            image.Width = 100;
            image = tempimage;
        }
        #endregion
    }
}
